#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	setup
Version		:	2.13.6
Release		:	14.4.0.0%{?dist}
Summary		:	A set of system configuration and setup files
Group		:	System Environment/Base

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Public Domain
URL		:	https://releases.pagure.org/setup/

Source0		:	%{name}-%{version}.tar.bz2
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	bash

Requires	:	filesystem
Requires	:	/usr/bin/bash

BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description
The setup package contains a set of important system configuration and
setup files, such as passwd, group, and profile.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING uidgid
%dir /root
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/passwd
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/group
%verify(not md5 size mtime) %attr(0000,root,root) %config(noreplace,missingok) %{_sysconfdir}/shadow
%verify(not md5 size mtime) %attr(0000,root,root) %config(noreplace,missingok) %{_sysconfdir}/gshadow
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/subuid
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/subgid
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/exports
%config(noreplace) %{_sysconfdir}/aliases
%config(noreplace) %{_sysconfdir}/environment
%config(noreplace) %{_sysconfdir}/fstab
%config(noreplace) %{_sysconfdir}/filesystems
%config(noreplace) %{_sysconfdir}/host.conf
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/hosts
%config(noreplace) %{_sysconfdir}/hosts.allow
%config(noreplace) %{_sysconfdir}/hosts.deny
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/motd
%config(noreplace) %{_sysconfdir}/printcap
%verify(not md5 size mtime) %config(noreplace) %{_sysconfdir}/inputrc
%config(noreplace) %{_sysconfdir}/bashrc
%config(noreplace) %{_sysconfdir}/profile
%config(noreplace) %{_sysconfdir}/ethertypes
%config(noreplace) %{_sysconfdir}/csh.login
%config(noreplace) %{_sysconfdir}/csh.cshrc
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/shells
%config(noreplace,missingok) %{_sysconfdir}/mtab
%config(noreplace,missingok) %{_sysconfdir}/profile.d/*.sh
%config(noreplace) %{_sysconfdir}/zypp/repos.d/OK-*.repo

%ghost %attr(0644,root,root) %verify(not md5 size mtime) /var/log/lastlog

%{_sysconfdir}/lang.{sh,csh}
%{_sysconfdir}/networks

%dir /home

#-----------------------------------------------------------------------------
%posttrans

#removing useless file
for file in passwd shadow group gshadow
  do
  if [ -f %{_sysconfdir}/$file.rpmnew ] ; then
    # echo "removing file %{_sysconfdir}/$file.rpmnew"
    rm -f %{_sysconfdir}/$file.rpmnew
    fi
  done

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

#adding group definition
echo "kvm:x:36:" >> group
echo "netdev:x:62:" >> group
echo "input:x:200:" >> group

#to have 'users' group compatible with shadow
sed -i							\
  -e "s/users::100:/users::1000:/"			\
  group

#converting passwd to shadow mode
./shadowconvert.sh

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/profile.d
%{__cp} -a * %{buildroot}%{_sysconfdir}

touch %{buildroot}%{_sysconfdir}/environment

%{__ln_s} ../proc/mounts %{buildroot}%{_sysconfdir}/mtab

%{__chmod} 0644 %{buildroot}%{_sysconfdir}/environment
%{__chmod} 0400 %{buildroot}%{_sysconfdir}/{shadow,gshadow}

#to add some color to ls function
cat >> %{buildroot}%{_sysconfdir}/bashrc << EOF
#----------------------------------------------------------------------
#Added by Osukiss
export LS_OPTIONS='--color=auto'
eval "\$(dircolors -b)"
alias ls='ls \$LS_OPTIONS'
#----------------------------------------------------------------------
EOF


#Brand new installation without root password
sed -i							\
   -e "s/root:\*:/root::/"				\
   %{buildroot}%{_sysconfdir}/shadow

#changing "wrong" group id for games
sed -i							\
    "/^games/s/100/20/"					\
   %{buildroot}%{_sysconfdir}/passwd

#creating an empty fstab
touch %{buildroot}%{_sysconfdir}/fstab

%{__mkdir_p} %{buildroot}/var/log
touch %{buildroot}/var/log/lastlog
%{__chmod} 0644 %{buildroot}/var/log/lastlog

#creating user home directory
%{__mkdir_p} %{buildroot}/home

#creating the root password
%{__mkdir_p} %{buildroot}/root
%{__mkdir_p} %{buildroot}%{_sysconfdir}/zypp/repos.d

# remove unpackaged files from the buildroot
%{__rm} -f  %{buildroot}%{_sysconfdir}/{uidgid,COPYING}
%{__rm} -f  %{buildroot}%{_sysconfdir}/Makefile
%{__rm} -f  %{buildroot}%{_sysconfdir}/serviceslint
%{__rm} -f  %{buildroot}%{_sysconfdir}/uidgidlint
%{__rm} -f  %{buildroot}%{_sysconfdir}/shadowconvert.sh
%{__rm} -f  %{buildroot}%{_sysconfdir}/setup.spec
%{__rm} -fr %{buildroot}%{_sysconfdir}/contrib
%{__rm} -fr %{buildroot}%{_sysconfdir}/protocols
%{__rm} -fr %{buildroot}%{_sysconfdir}/services

#extracting addon files
tar xf %{SOURCE1}

(
pushd  %{name}-ok_addon
%{__cp} -a						\
	hosts.allow					\
	hosts.deny 					\
	profile.d 					\
	profile						\
	bashrc						\
	%{buildroot}%{_sysconfdir}

%{__cp} -a						\
	OK-*repo					\
	%{buildroot}%{_sysconfdir}/zypp/repos.d

popd
)

#-----------------------------------------------------------------------------
%changelog
